Index: binutils-gdb/gdb/Makefile.in
===================================================================
--- binutils-gdb.orig/gdb/Makefile.in
+++ binutils-gdb/gdb/Makefile.in
@@ -1214,6 +1214,7 @@ SFILES = \
 	tracepoint.c \
 	trad-frame.c \
 	tramp-frame.c \
+	target-float.c \
 	typeprint.c \
 	ui-file.c \
 	ui-file.h \
@@ -1482,6 +1483,7 @@ HFILES_NO_SRCDIR = \
 	tracefile.h \
 	tracepoint.h \
 	trad-frame.h \
+	target-float.h \
 	tramp-frame.h \
 	typeprint.h \
 	ui-file.h \
@@ -1832,6 +1834,7 @@ COMMON_OBS = $(DEPFILES) $(CONFIG_OBS) $
 	top.o \
 	trad-frame.o \
 	tramp-frame.o \
+	target-float.o \
 	typeprint.o \
 	ui-file.o \
 	ui-out.o \
Index: binutils-gdb/gdb/target-float.c
===================================================================
--- /dev/null
+++ binutils-gdb/gdb/target-float.c
@@ -0,0 +1,62 @@
+/* Floating point routines for GDB, the GNU debugger.
+
+   Copyright (C) 2017 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "defs.h"
+#include "dfp.h"
+#include "doublest.h"
+#include "gdbtypes.h"
+#include "floatformat.h"
+#include "target-float.h"
+
+
+/* Typed floating-point routines.  These routines operate on floating-point
+   values in target format, represented by a byte buffer interpreted as a
+   "struct type", which may be either a binary or decimal floating-point
+   type (TYPE_CODE_FLT or TYPE_CODE_DECFLOAT).  */
+
+/* Return whether the byte-stream ADDR holds a valid value of
+   floating-point type TYPE.  */
+bool
+target_float_is_valid (const gdb_byte *addr, const struct type *type)
+{
+  if (TYPE_CODE (type) == TYPE_CODE_FLT)
+    return floatformat_is_valid (floatformat_from_type (type), addr);
+
+  if (TYPE_CODE (type) == TYPE_CODE_DECFLOAT)
+    return true;
+
+  gdb_assert_not_reached ("unexpected type code");
+}
+
+/* Return whether the byte-stream ADDR, interpreted as floating-point
+   type TYPE, is numerically equal to zero (of either sign).  */
+bool
+target_float_is_zero (const gdb_byte *addr, const struct type *type)
+{
+  if (TYPE_CODE (type) == TYPE_CODE_FLT)
+    return (floatformat_classify (floatformat_from_type (type), addr)
+	    == float_zero);
+
+  if (TYPE_CODE (type) == TYPE_CODE_DECFLOAT)
+    return decimal_is_zero (addr, TYPE_LENGTH (type),
+			    gdbarch_byte_order (get_type_arch (type)));
+
+  gdb_assert_not_reached ("unexpected type code");
+}
+
Index: binutils-gdb/gdb/target-float.h
===================================================================
--- /dev/null
+++ binutils-gdb/gdb/target-float.h
@@ -0,0 +1,28 @@
+/* Floating point definitions for GDB.
+
+   Copyright (C) 1986-2017 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#ifndef TYPED_FLOAT_H
+#define TYPED_FLOAT_H
+
+extern bool target_float_is_valid (const gdb_byte *addr,
+				   const struct type *type);
+extern bool target_float_is_zero (const gdb_byte *addr,
+				  const struct type *type);
+
+#endif
Index: binutils-gdb/gdb/doublest.c
===================================================================
--- binutils-gdb.orig/gdb/doublest.c
+++ binutils-gdb/gdb/doublest.c
@@ -594,8 +594,13 @@ floatformat_classify (const struct float
 	return float_normal;
     }
 
-  if (exponent == 0 && !mant_zero)
-    return float_subnormal;
+  if (exponent == 0)
+    {
+      if (mant_zero)
+	return float_zero;
+      else
+	return float_subnormal;
+    }
 
   if (exponent == fmt->exp_nan)
     {
@@ -605,9 +610,6 @@ floatformat_classify (const struct float
 	return float_nan;
     }
 
-  if (mant_zero)
-    return float_zero;
-
   return float_normal;
 }
 
Index: binutils-gdb/gdb/gdbtypes.c
===================================================================
--- binutils-gdb.orig/gdb/gdbtypes.c
+++ binutils-gdb/gdb/gdbtypes.c
@@ -2935,6 +2935,16 @@ is_integral_type (struct type *t)
 	 || (TYPE_CODE (t) == TYPE_CODE_BOOL)));
 }
 
+int
+is_floating_type (struct type *t)
+{
+  t = check_typedef (t);
+  return
+    ((t != NULL)
+     && ((TYPE_CODE (t) == TYPE_CODE_FLT)
+	 || (TYPE_CODE (t) == TYPE_CODE_DECFLOAT)));
+}
+
 /* Return true if TYPE is scalar.  */
 
 int
Index: binutils-gdb/gdb/gdbtypes.h
===================================================================
--- binutils-gdb.orig/gdb/gdbtypes.h
+++ binutils-gdb/gdb/gdbtypes.h
@@ -1927,6 +1927,8 @@ extern int can_dereference (struct type
 
 extern int is_integral_type (struct type *);
 
+extern int is_floating_type (struct type *);
+
 extern int is_scalar_type (struct type *type);
 
 extern int is_scalar_type_recursive (struct type *);
Index: binutils-gdb/gdb/value.c
===================================================================
--- binutils-gdb.orig/gdb/value.c
+++ binutils-gdb/gdb/value.c
@@ -29,10 +29,10 @@
 #include "language.h"
 #include "demangle.h"
 #include "doublest.h"
-#include "floatformat.h"
 #include "regcache.h"
 #include "block.h"
 #include "dfp.h"
+#include "target-float.h"
 #include "objfiles.h"
 #include "valprint.h"
 #include "cli/cli-decode.h"
@@ -2967,24 +2967,7 @@ unpack_double (struct type *type, const
   nosign = TYPE_UNSIGNED (type);
   if (code == TYPE_CODE_FLT)
     {
-      /* NOTE: cagney/2002-02-19: There was a test here to see if the
-	 floating-point value was valid (using the macro
-	 INVALID_FLOAT).  That test/macro have been removed.
-
-	 It turns out that only the VAX defined this macro and then
-	 only in a non-portable way.  Fixing the portability problem
-	 wouldn't help since the VAX floating-point code is also badly
-	 bit-rotten.  The target needs to add definitions for the
-	 methods gdbarch_float_format and gdbarch_double_format - these
-	 exactly describe the target floating-point format.  The
-	 problem here is that the corresponding floatformat_vax_f and
-	 floatformat_vax_d values these methods should be set to are
-	 also not defined either.  Oops!
-
-         Hopefully someone will add both the missing floatformat
-         definitions and the new cases for floatformat_is_valid ().  */
-
-      if (!floatformat_is_valid (floatformat_from_type (type), valaddr))
+      if (!target_float_is_valid (valaddr, type))
 	{
 	  *invp = 1;
 	  return 0.0;
@@ -3027,6 +3010,21 @@ unpack_pointer (struct type *type, const
   return unpack_long (type, valaddr);
 }
 
+bool
+is_floating_value (struct value *val)
+{
+  struct type *type = check_typedef (value_type (val));
+
+  if (is_floating_type (type))
+    {
+      if (!target_float_is_valid (value_contents (val), type))
+	error (_("Invalid floating value found in program."));
+      return true;
+    }
+
+  return false;
+}
+
 
 /* Get the value of the FIELDNO'th field (which must be static) of
    TYPE.  */
Index: binutils-gdb/gdb/value.h
===================================================================
--- binutils-gdb.orig/gdb/value.h
+++ binutils-gdb/gdb/value.h
@@ -608,6 +608,10 @@ extern int print_address_demangle (const
 				   struct gdbarch *, CORE_ADDR,
 				   struct ui_file *, int);
 
+/* Returns true if VAL is of floating-point type.  In addition,
+   throws an error if the value is an invalid floating-point value.  */
+extern bool is_floating_value (struct value *val);
+
 extern LONGEST value_as_long (struct value *val);
 extern DOUBLEST value_as_double (struct value *val);
 extern CORE_ADDR value_as_address (struct value *val);
Index: binutils-gdb/gdb/valarith.c
===================================================================
--- binutils-gdb.orig/gdb/valarith.c
+++ binutils-gdb/gdb/valarith.c
@@ -26,6 +26,7 @@
 #include "language.h"
 #include "doublest.h"
 #include "dfp.h"
+#include "target-float.h"
 #include <math.h>
 #include "infcall.h"
 
@@ -1517,11 +1518,8 @@ value_logical_not (struct value *arg1)
   arg1 = coerce_array (arg1);
   type1 = check_typedef (value_type (arg1));
 
-  if (TYPE_CODE (type1) == TYPE_CODE_FLT)
-    return 0 == value_as_double (arg1);
-  else if (TYPE_CODE (type1) == TYPE_CODE_DECFLOAT)
-    return decimal_is_zero (value_contents (arg1), TYPE_LENGTH (type1),
-			    gdbarch_byte_order (get_type_arch (type1)));
+  if (is_floating_value (arg1))
+    return target_float_is_zero (value_contents (arg1), type1);
 
   len = TYPE_LENGTH (type1);
   p = value_contents (arg1);
Index: binutils-gdb/gdb/python/py-value.c
===================================================================
--- binutils-gdb.orig/gdb/python/py-value.c
+++ binutils-gdb/gdb/python/py-value.c
@@ -21,7 +21,7 @@
 #include "charset.h"
 #include "value.h"
 #include "language.h"
-#include "dfp.h"
+#include "target-float.h"
 #include "valprint.h"
 #include "infcall.h"
 #include "expression.h"
@@ -1317,12 +1317,9 @@ valpy_nonzero (PyObject *self)
 
       if (is_integral_type (type) || TYPE_CODE (type) == TYPE_CODE_PTR)
 	nonzero = !!value_as_long (self_value->value);
-      else if (TYPE_CODE (type) == TYPE_CODE_FLT)
-	nonzero = value_as_double (self_value->value) != 0;
-      else if (TYPE_CODE (type) == TYPE_CODE_DECFLOAT)
-	nonzero = !decimal_is_zero (value_contents (self_value->value),
-				 TYPE_LENGTH (type),
-				 gdbarch_byte_order (get_type_arch (type)));
+      else if (is_floating_value (self_value->value))
+	nonzero = !target_float_is_zero (value_contents (self_value->value),
+					 type);
       else
 	/* All other values are True.  */
 	nonzero = 1;